<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>11.2. os.path — Common pathname manipulations &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="11. File and Directory Access" href="filesys.html" />
    <link rel="next" title="11.3. fileinput — Iterate over lines from multiple input streams" href="fileinput.html" />
    <link rel="prev" title="11.1. pathlib — Object-oriented filesystem paths" href="pathlib.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="fileinput.html" title="11.3. fileinput — Iterate over lines from multiple input streams"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pathlib.html" title="11.1. pathlib — Object-oriented filesystem paths"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="filesys.html" accesskey="U">11. File and Directory Access</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-os.path">
<span id="os-path-common-pathname-manipulations"></span><h1>11.2. <a class="reference internal" href="#module-os.path" title="os.path: Operations on pathnames."><code class="xref py py-mod docutils literal"><span class="pre">os.path</span></code></a> &#8212; Common pathname manipulations<a class="headerlink" href="#module-os.path" title="Permalink to this headline">¶</a></h1>
<p id="index-0">This module implements some useful functions on pathnames. To read or
write files see <a class="reference internal" href="functions.html#open" title="open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a>, and for accessing the filesystem see the
<a class="reference internal" href="os.html#module-os" title="os: Miscellaneous operating system interfaces."><code class="xref py py-mod docutils literal"><span class="pre">os</span></code></a> module. The path parameters can be passed as either strings,
or bytes. Applications are encouraged to represent file names as
(Unicode) character strings. Unfortunately, some file names may not be
representable as strings on Unix, so applications that need to support
arbitrary file names on Unix should use bytes objects to represent
path names. Vice versa, using bytes objects cannot represent all file
names on Windows (in the standard <code class="docutils literal"><span class="pre">mbcs</span></code> encoding), hence Windows
applications should use string objects to access all files.</p>
<p>Unlike a unix shell, Python does not do any <em>automatic</em> path expansions.
Functions such as <a class="reference internal" href="#os.path.expanduser" title="os.path.expanduser"><code class="xref py py-func docutils literal"><span class="pre">expanduser()</span></code></a> and <a class="reference internal" href="#os.path.expandvars" title="os.path.expandvars"><code class="xref py py-func docutils literal"><span class="pre">expandvars()</span></code></a> can be invoked
explicitly when an application desires shell-like path expansion.  (See also
the <a class="reference internal" href="glob.html#module-glob" title="glob: Unix shell style pathname pattern expansion."><code class="xref py py-mod docutils literal"><span class="pre">glob</span></code></a> module.)</p>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<p class="last">The <a class="reference internal" href="pathlib.html#module-pathlib" title="pathlib: Object-oriented filesystem paths"><code class="xref py py-mod docutils literal"><span class="pre">pathlib</span></code></a> module offers high-level path objects.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">All of these functions accept either only bytes or only string objects as
their parameters.  The result is an object of the same type, if a path or
file name is returned.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>Since different operating systems have different path name conventions, there
are several versions of this module in the standard library.  The
<a class="reference internal" href="#module-os.path" title="os.path: Operations on pathnames."><code class="xref py py-mod docutils literal"><span class="pre">os.path</span></code></a> module is always the path module suitable for the operating
system Python is running on, and therefore usable for local paths.  However,
you can also import and use the individual modules if you want to manipulate
a path that is <em>always</em> in one of the different formats.  They all have the
same interface:</p>
<ul class="last simple">
<li><code class="xref py py-mod docutils literal"><span class="pre">posixpath</span></code> for UNIX-style paths</li>
<li><code class="xref py py-mod docutils literal"><span class="pre">ntpath</span></code> for Windows paths</li>
<li><a class="reference internal" href="macpath.html#module-macpath" title="macpath: Mac OS 9 path manipulation functions."><code class="xref py py-mod docutils literal"><span class="pre">macpath</span></code></a> for old-style MacOS paths</li>
</ul>
</div>
<dl class="function">
<dt id="os.path.abspath">
<code class="descclassname">os.path.</code><code class="descname">abspath</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.abspath" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a normalized absolutized version of the pathname <em>path</em>. On most
platforms, this is equivalent to calling the function <a class="reference internal" href="#os.path.normpath" title="os.path.normpath"><code class="xref py py-func docutils literal"><span class="pre">normpath()</span></code></a> as
follows: <code class="docutils literal"><span class="pre">normpath(join(os.getcwd(),</span> <span class="pre">path))</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.basename">
<code class="descclassname">os.path.</code><code class="descname">basename</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.basename" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the base name of pathname <em>path</em>.  This is the second element of the
pair returned by passing <em>path</em> to the function <a class="reference internal" href="#os.path.split" title="os.path.split"><code class="xref py py-func docutils literal"><span class="pre">split()</span></code></a>.  Note that
the result of this function is different
from the Unix <strong class="program">basename</strong> program; where <strong class="program">basename</strong> for
<code class="docutils literal"><span class="pre">'/foo/bar/'</span></code> returns <code class="docutils literal"><span class="pre">'bar'</span></code>, the <a class="reference internal" href="#os.path.basename" title="os.path.basename"><code class="xref py py-func docutils literal"><span class="pre">basename()</span></code></a> function returns an
empty string (<code class="docutils literal"><span class="pre">''</span></code>).</p>
</dd></dl>

<dl class="function">
<dt id="os.path.commonpath">
<code class="descclassname">os.path.</code><code class="descname">commonpath</code><span class="sig-paren">(</span><em>paths</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.commonpath" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the longest common sub-path of each pathname in the sequence
<em>paths</em>.  Raise ValueError if <em>paths</em> contains both absolute and relative
pathnames, or if <em>paths</em> is empty.  Unlike <a class="reference internal" href="#os.path.commonprefix" title="os.path.commonprefix"><code class="xref py py-func docutils literal"><span class="pre">commonprefix()</span></code></a>, this
returns a valid path.</p>
<p>Availability: Unix, Windows</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.commonprefix">
<code class="descclassname">os.path.</code><code class="descname">commonprefix</code><span class="sig-paren">(</span><em>list</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.commonprefix" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the longest path prefix (taken character-by-character) that is a
prefix of all paths in  <em>list</em>.  If <em>list</em> is empty, return the empty string
(<code class="docutils literal"><span class="pre">''</span></code>).</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>This function may return invalid paths because it works a
character at a time.  To obtain a valid path, see
<a class="reference internal" href="#os.path.commonpath" title="os.path.commonpath"><code class="xref py py-func docutils literal"><span class="pre">commonpath()</span></code></a>.</p>
<div class="last highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">commonprefix</span><span class="p">([</span><span class="s">&#39;/usr/lib&#39;</span><span class="p">,</span> <span class="s">&#39;/usr/local/lib&#39;</span><span class="p">])</span>
<span class="go">&#39;/usr/l&#39;</span>

<span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">commonpath</span><span class="p">([</span><span class="s">&#39;/usr/lib&#39;</span><span class="p">,</span> <span class="s">&#39;/usr/local/lib&#39;</span><span class="p">])</span>
<span class="go">&#39;/usr&#39;</span>
</pre></div>
</div>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.dirname">
<code class="descclassname">os.path.</code><code class="descname">dirname</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.dirname" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the directory name of pathname <em>path</em>.  This is the first element of
the pair returned by passing <em>path</em> to the function <a class="reference internal" href="#os.path.split" title="os.path.split"><code class="xref py py-func docutils literal"><span class="pre">split()</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.exists">
<code class="descclassname">os.path.</code><code class="descname">exists</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.exists" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> refers to an existing path or an open
file descriptor.  Returns <code class="docutils literal"><span class="pre">False</span></code> for broken symbolic links.  On
some platforms, this function may return <code class="docutils literal"><span class="pre">False</span></code> if permission is
not granted to execute <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a> on the requested file, even
if the <em>path</em> physically exists.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span><em>path</em> can now be an integer: <code class="docutils literal"><span class="pre">True</span></code> is returned if it is an
 open file descriptor, <code class="docutils literal"><span class="pre">False</span></code> otherwise.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.lexists">
<code class="descclassname">os.path.</code><code class="descname">lexists</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.lexists" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> refers to an existing path. Returns <code class="docutils literal"><span class="pre">True</span></code> for
broken symbolic links.   Equivalent to <a class="reference internal" href="#os.path.exists" title="os.path.exists"><code class="xref py py-func docutils literal"><span class="pre">exists()</span></code></a> on platforms lacking
<a class="reference internal" href="os.html#os.lstat" title="os.lstat"><code class="xref py py-func docutils literal"><span class="pre">os.lstat()</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.expanduser">
<code class="descclassname">os.path.</code><code class="descname">expanduser</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.expanduser" title="Permalink to this definition">¶</a></dt>
<dd><p>On Unix and Windows, return the argument with an initial component of <code class="docutils literal"><span class="pre">~</span></code> or
<code class="docutils literal"><span class="pre">~user</span></code> replaced by that <em>user</em>&#8216;s home directory.</p>
<p id="index-1">On Unix, an initial <code class="docutils literal"><span class="pre">~</span></code> is replaced by the environment variable <span class="target" id="index-2"></span><code class="xref std std-envvar docutils literal"><span class="pre">HOME</span></code>
if it is set; otherwise the current user&#8217;s home directory is looked up in the
password directory through the built-in module <a class="reference internal" href="pwd.html#module-pwd" title="pwd: The password database (getpwnam() and friends). (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">pwd</span></code></a>. An initial <code class="docutils literal"><span class="pre">~user</span></code>
is looked up directly in the password directory.</p>
<p>On Windows, <span class="target" id="index-3"></span><code class="xref std std-envvar docutils literal"><span class="pre">HOME</span></code> and <span class="target" id="index-4"></span><code class="xref std std-envvar docutils literal"><span class="pre">USERPROFILE</span></code> will be used if set,
otherwise a combination of <span class="target" id="index-5"></span><code class="xref std std-envvar docutils literal"><span class="pre">HOMEPATH</span></code> and <span class="target" id="index-6"></span><code class="xref std std-envvar docutils literal"><span class="pre">HOMEDRIVE</span></code> will be
used.  An initial <code class="docutils literal"><span class="pre">~user</span></code> is handled by stripping the last directory component
from the created user path derived above.</p>
<p>If the expansion fails or if the path does not begin with a tilde, the path is
returned unchanged.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.expandvars">
<code class="descclassname">os.path.</code><code class="descname">expandvars</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.expandvars" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the argument with environment variables expanded.  Substrings of the form
<code class="docutils literal"><span class="pre">$name</span></code> or <code class="docutils literal"><span class="pre">${name}</span></code> are replaced by the value of environment variable
<em>name</em>.  Malformed variable names and references to non-existing variables are
left unchanged.</p>
<p>On Windows, <code class="docutils literal"><span class="pre">%name%</span></code> expansions are supported in addition to <code class="docutils literal"><span class="pre">$name</span></code> and
<code class="docutils literal"><span class="pre">${name}</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.getatime">
<code class="descclassname">os.path.</code><code class="descname">getatime</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.getatime" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the time of last access of <em>path</em>.  The return value is a number giving
the number of seconds since the epoch (see the  <a class="reference internal" href="time.html#module-time" title="time: Time access and conversions."><code class="xref py py-mod docutils literal"><span class="pre">time</span></code></a> module).  Raise
<a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> if the file does not exist or is inaccessible.</p>
<p>If <a class="reference internal" href="os.html#os.stat_float_times" title="os.stat_float_times"><code class="xref py py-func docutils literal"><span class="pre">os.stat_float_times()</span></code></a> returns <code class="docutils literal"><span class="pre">True</span></code>, the result is a floating point
number.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.getmtime">
<code class="descclassname">os.path.</code><code class="descname">getmtime</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.getmtime" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the time of last modification of <em>path</em>.  The return value is a number
giving the number of seconds since the epoch (see the  <a class="reference internal" href="time.html#module-time" title="time: Time access and conversions."><code class="xref py py-mod docutils literal"><span class="pre">time</span></code></a> module).
Raise <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> if the file does not exist or is inaccessible.</p>
<p>If <a class="reference internal" href="os.html#os.stat_float_times" title="os.stat_float_times"><code class="xref py py-func docutils literal"><span class="pre">os.stat_float_times()</span></code></a> returns <code class="docutils literal"><span class="pre">True</span></code>, the result is a floating point
number.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.getctime">
<code class="descclassname">os.path.</code><code class="descname">getctime</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.getctime" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the system&#8217;s ctime which, on some systems (like Unix) is the time of the
last metadata change, and, on others (like Windows), is the creation time for <em>path</em>.
The return value is a number giving the number of seconds since the epoch (see
the  <a class="reference internal" href="time.html#module-time" title="time: Time access and conversions."><code class="xref py py-mod docutils literal"><span class="pre">time</span></code></a> module).  Raise <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> if the file does not exist or
is inaccessible.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.getsize">
<code class="descclassname">os.path.</code><code class="descname">getsize</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.getsize" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the size, in bytes, of <em>path</em>.  Raise <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> if the file does
not exist or is inaccessible.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.isabs">
<code class="descclassname">os.path.</code><code class="descname">isabs</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.isabs" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> is an absolute pathname.  On Unix, that means it
begins with a slash, on Windows that it begins with a (back)slash after chopping
off a potential drive letter.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.isfile">
<code class="descclassname">os.path.</code><code class="descname">isfile</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.isfile" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> is an existing regular file.  This follows symbolic
links, so both <a class="reference internal" href="#os.path.islink" title="os.path.islink"><code class="xref py py-func docutils literal"><span class="pre">islink()</span></code></a> and <a class="reference internal" href="#os.path.isfile" title="os.path.isfile"><code class="xref py py-func docutils literal"><span class="pre">isfile()</span></code></a> can be true for the same path.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.isdir">
<code class="descclassname">os.path.</code><code class="descname">isdir</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.isdir" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> is an existing directory.  This follows symbolic
links, so both <a class="reference internal" href="#os.path.islink" title="os.path.islink"><code class="xref py py-func docutils literal"><span class="pre">islink()</span></code></a> and <a class="reference internal" href="#os.path.isdir" title="os.path.isdir"><code class="xref py py-func docutils literal"><span class="pre">isdir()</span></code></a> can be true for the same path.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.islink">
<code class="descclassname">os.path.</code><code class="descname">islink</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.islink" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if <em>path</em> refers to a directory entry that is a symbolic link.
Always <code class="docutils literal"><span class="pre">False</span></code> if symbolic links are not supported by the python runtime.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.ismount">
<code class="descclassname">os.path.</code><code class="descname">ismount</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.ismount" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if pathname <em>path</em> is a <em class="dfn">mount point</em>: a point in a
file system where a different file system has been mounted.  On POSIX, the
function checks whether <em>path</em>&#8216;s parent, <code class="file docutils literal"><span class="pre">path/..</span></code>, is on a different
device than <em>path</em>, or whether <code class="file docutils literal"><span class="pre">path/..</span></code> and <em>path</em> point to the same
i-node on the same device &#8212; this should detect mount points for all Unix
and POSIX variants.  On Windows, a drive letter root and a share UNC are
always mount points, and for any other path <code class="docutils literal"><span class="pre">GetVolumePathName</span></code> is called
to see if it is different from the input path.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4: </span>Support for detecting non-root mount points on Windows.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.join">
<code class="descclassname">os.path.</code><code class="descname">join</code><span class="sig-paren">(</span><em>path</em>, <em>*paths</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.join" title="Permalink to this definition">¶</a></dt>
<dd><p>Join one or more path components intelligently.  The return value is the
concatenation of <em>path</em> and any members of <em>*paths</em> with exactly one
directory separator (<code class="docutils literal"><span class="pre">os.sep</span></code>) following each non-empty part except the
last, meaning that the result will only end in a separator if the last
part is empty.  If a component is an absolute path, all previous
components are thrown away and joining continues from the absolute path
component.</p>
<p>On Windows, the drive letter is not reset when an absolute path component
(e.g., <code class="docutils literal"><span class="pre">r'\foo'</span></code>) is encountered.  If a component contains a drive
letter, all previous components are thrown away and the drive letter is
reset.  Note that since there is a current directory for each drive,
<code class="docutils literal"><span class="pre">os.path.join(&quot;c:&quot;,</span> <span class="pre">&quot;foo&quot;)</span></code> represents a path relative to the current
directory on drive <code class="file docutils literal"><span class="pre">C:</span></code> (<code class="file docutils literal"><span class="pre">c:foo</span></code>), not <code class="file docutils literal"><span class="pre">c:\foo</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.normcase">
<code class="descclassname">os.path.</code><code class="descname">normcase</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.normcase" title="Permalink to this definition">¶</a></dt>
<dd><p>Normalize the case of a pathname.  On Unix and Mac OS X, this returns the
path unchanged; on case-insensitive filesystems, it converts the path to
lowercase.  On Windows, it also converts forward slashes to backward slashes.
Raise a TypeError if the type of <em>path</em> is not <code class="docutils literal"><span class="pre">str</span></code> or <code class="docutils literal"><span class="pre">bytes</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.normpath">
<code class="descclassname">os.path.</code><code class="descname">normpath</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.normpath" title="Permalink to this definition">¶</a></dt>
<dd><p>Normalize a pathname by collapsing redundant separators and up-level
references so that <code class="docutils literal"><span class="pre">A//B</span></code>, <code class="docutils literal"><span class="pre">A/B/</span></code>, <code class="docutils literal"><span class="pre">A/./B</span></code> and <code class="docutils literal"><span class="pre">A/foo/../B</span></code> all
become <code class="docutils literal"><span class="pre">A/B</span></code>.  This string manipulation may change the meaning of a path
that contains symbolic links.  On Windows, it converts forward slashes to
backward slashes. To normalize case, use <a class="reference internal" href="#os.path.normcase" title="os.path.normcase"><code class="xref py py-func docutils literal"><span class="pre">normcase()</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.realpath">
<code class="descclassname">os.path.</code><code class="descname">realpath</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.realpath" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the canonical path of the specified filename, eliminating any symbolic
links encountered in the path (if they are supported by the operating system).</p>
</dd></dl>

<dl class="function">
<dt id="os.path.relpath">
<code class="descclassname">os.path.</code><code class="descname">relpath</code><span class="sig-paren">(</span><em>path</em>, <em>start=os.curdir</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.relpath" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a relative filepath to <em>path</em> either from the current directory or
from an optional <em>start</em> directory.  This is a path computation:  the
filesystem is not accessed to confirm the existence or nature of <em>path</em> or
<em>start</em>.</p>
<p><em>start</em> defaults to <a class="reference internal" href="os.html#os.curdir" title="os.curdir"><code class="xref py py-attr docutils literal"><span class="pre">os.curdir</span></code></a>.</p>
<p>Availability: Unix, Windows.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.samefile">
<code class="descclassname">os.path.</code><code class="descname">samefile</code><span class="sig-paren">(</span><em>path1</em>, <em>path2</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.samefile" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if both pathname arguments refer to the same file or directory.
This is determined by the device number and i-node number and raises an
exception if an <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a> call on either pathname fails.</p>
<p>Availability: Unix, Windows.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Added Windows support.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Windows now uses the same implementation as all other platforms.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.sameopenfile">
<code class="descclassname">os.path.</code><code class="descname">sameopenfile</code><span class="sig-paren">(</span><em>fp1</em>, <em>fp2</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.sameopenfile" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if the file descriptors <em>fp1</em> and <em>fp2</em> refer to the same file.</p>
<p>Availability: Unix, Windows.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Added Windows support.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.samestat">
<code class="descclassname">os.path.</code><code class="descname">samestat</code><span class="sig-paren">(</span><em>stat1</em>, <em>stat2</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.samestat" title="Permalink to this definition">¶</a></dt>
<dd><p>Return <code class="docutils literal"><span class="pre">True</span></code> if the stat tuples <em>stat1</em> and <em>stat2</em> refer to the same file.
These structures may have been returned by <a class="reference internal" href="os.html#os.fstat" title="os.fstat"><code class="xref py py-func docutils literal"><span class="pre">os.fstat()</span></code></a>,
<a class="reference internal" href="os.html#os.lstat" title="os.lstat"><code class="xref py py-func docutils literal"><span class="pre">os.lstat()</span></code></a>, or <a class="reference internal" href="os.html#os.stat" title="os.stat"><code class="xref py py-func docutils literal"><span class="pre">os.stat()</span></code></a>.  This function implements the
underlying comparison used by <a class="reference internal" href="#os.path.samefile" title="os.path.samefile"><code class="xref py py-func docutils literal"><span class="pre">samefile()</span></code></a> and <a class="reference internal" href="#os.path.sameopenfile" title="os.path.sameopenfile"><code class="xref py py-func docutils literal"><span class="pre">sameopenfile()</span></code></a>.</p>
<p>Availability: Unix, Windows.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added Windows support.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="os.path.split">
<code class="descclassname">os.path.</code><code class="descname">split</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.split" title="Permalink to this definition">¶</a></dt>
<dd><p>Split the pathname <em>path</em> into a pair, <code class="docutils literal"><span class="pre">(head,</span> <span class="pre">tail)</span></code> where <em>tail</em> is the
last pathname component and <em>head</em> is everything leading up to that.  The
<em>tail</em> part will never contain a slash; if <em>path</em> ends in a slash, <em>tail</em>
will be empty.  If there is no slash in <em>path</em>, <em>head</em> will be empty.  If
<em>path</em> is empty, both <em>head</em> and <em>tail</em> are empty.  Trailing slashes are
stripped from <em>head</em> unless it is the root (one or more slashes only).  In
all cases, <code class="docutils literal"><span class="pre">join(head,</span> <span class="pre">tail)</span></code> returns a path to the same location as <em>path</em>
(but the strings may differ).  Also see the functions <a class="reference internal" href="#os.path.dirname" title="os.path.dirname"><code class="xref py py-func docutils literal"><span class="pre">dirname()</span></code></a> and
<a class="reference internal" href="#os.path.basename" title="os.path.basename"><code class="xref py py-func docutils literal"><span class="pre">basename()</span></code></a>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.splitdrive">
<code class="descclassname">os.path.</code><code class="descname">splitdrive</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.splitdrive" title="Permalink to this definition">¶</a></dt>
<dd><p>Split the pathname <em>path</em> into a pair <code class="docutils literal"><span class="pre">(drive,</span> <span class="pre">tail)</span></code> where <em>drive</em> is either
a mount point or the empty string.  On systems which do not use drive
specifications, <em>drive</em> will always be the empty string.  In all cases, <code class="docutils literal"><span class="pre">drive</span>
<span class="pre">+</span> <span class="pre">tail</span></code> will be the same as <em>path</em>.</p>
<p>On Windows, splits a pathname into drive/UNC sharepoint and relative path.</p>
<p>If the path contains a drive letter, drive will contain everything
up to and including the colon.
e.g. <code class="docutils literal"><span class="pre">splitdrive(&quot;c:/dir&quot;)</span></code> returns <code class="docutils literal"><span class="pre">(&quot;c:&quot;,</span> <span class="pre">&quot;/dir&quot;)</span></code></p>
<p>If the path contains a UNC path, drive will contain the host name
and share, up to but not including the fourth separator.
e.g. <code class="docutils literal"><span class="pre">splitdrive(&quot;//host/computer/dir&quot;)</span></code> returns <code class="docutils literal"><span class="pre">(&quot;//host/computer&quot;,</span> <span class="pre">&quot;/dir&quot;)</span></code></p>
</dd></dl>

<dl class="function">
<dt id="os.path.splitext">
<code class="descclassname">os.path.</code><code class="descname">splitext</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.splitext" title="Permalink to this definition">¶</a></dt>
<dd><p>Split the pathname <em>path</em> into a pair <code class="docutils literal"><span class="pre">(root,</span> <span class="pre">ext)</span></code>  such that <code class="docutils literal"><span class="pre">root</span> <span class="pre">+</span> <span class="pre">ext</span> <span class="pre">==</span>
<span class="pre">path</span></code>, and <em>ext</em> is empty or begins with a period and contains at most one
period. Leading periods on the basename are  ignored; <code class="docutils literal"><span class="pre">splitext('.cshrc')</span></code>
returns  <code class="docutils literal"><span class="pre">('.cshrc',</span> <span class="pre">'')</span></code>.</p>
</dd></dl>

<dl class="function">
<dt id="os.path.splitunc">
<code class="descclassname">os.path.</code><code class="descname">splitunc</code><span class="sig-paren">(</span><em>path</em><span class="sig-paren">)</span><a class="headerlink" href="#os.path.splitunc" title="Permalink to this definition">¶</a></dt>
<dd><div class="deprecated">
<p><span class="versionmodified">Deprecated since version 3.1: </span>Use <em>splitdrive</em> instead.</p>
</div>
<p>Split the pathname <em>path</em> into a pair <code class="docutils literal"><span class="pre">(unc,</span> <span class="pre">rest)</span></code> so that <em>unc</em> is the UNC
mount point (such as <code class="docutils literal"><span class="pre">r'\\host\mount'</span></code>), if present, and <em>rest</em> the rest of
the path (such as  <code class="docutils literal"><span class="pre">r'\path\file.ext'</span></code>).  For paths containing drive letters,
<em>unc</em> will always be the empty string.</p>
<p>Availability:  Windows.</p>
</dd></dl>

<dl class="data">
<dt id="os.path.supports_unicode_filenames">
<code class="descclassname">os.path.</code><code class="descname">supports_unicode_filenames</code><a class="headerlink" href="#os.path.supports_unicode_filenames" title="Permalink to this definition">¶</a></dt>
<dd><p><code class="docutils literal"><span class="pre">True</span></code> if arbitrary Unicode strings can be used as file names (within limitations
imposed by the file system).</p>
</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="pathlib.html"
                        title="previous chapter">11.1. <code class="docutils literal"><span class="pre">pathlib</span></code> &#8212; Object-oriented filesystem paths</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="fileinput.html"
                        title="next chapter">11.3. <code class="docutils literal"><span class="pre">fileinput</span></code> &#8212; Iterate over lines from multiple input streams</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/os.path.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="fileinput.html" title="11.3. fileinput — Iterate over lines from multiple input streams"
             >next</a> |</li>
        <li class="right" >
          <a href="pathlib.html" title="11.1. pathlib — Object-oriented filesystem paths"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="filesys.html" >11. File and Directory Access</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>